package destination;

import javax.jms.Topic;
import javax.jms.TopicConnectionFactory;

import javax.naming.Context;
import javax.naming.InitialContext;

import com.sssw.jms.api.JMQTopic;
import com.sssw.jms.api.JMQDestination;
import com.sssw.jms.api.JMQTopicConnection;

import com.sssw.jms.api.admin.JMQDestinationAdmin;

// Note: destination deletion requires private APIs

public class DestroyTopic
{
    public static void main(String[] args) throws Exception
    {
	// get the initial context
	InitialContext ctx = new InitialContext();

	// destroy a destination topic

	// create a JMS Topic Connection
	TopicConnectionFactory tconFactory = (TopicConnectionFactory) ctx.
	    lookup("topic/connectionFactory");
	JMQTopicConnection topicConn = (JMQTopicConnection) tconFactory.
	    createTopicConnection();

	// destroy the topic
	String topicName = (args.length > 0) ? args[0] : "myTopic";
	topicConn.getDestinationAdmin().deleteDestination(topicName, 
	    JMQDestination.TOPIC);
	System.out.println("Destroyed topic: " + topicName);

	// close the topic connection
	topicConn.close();
    }
}