import javax.jms.Queue;

import javax.naming.Context;
import javax.naming.InitialContext;

import javax.jms.Queue;
import javax.jms.Session;
import javax.jms.Message;
import javax.jms.TextMessage;
import javax.jms.ObjectMessage;
import javax.jms.QueueSender;
import javax.jms.DeliveryMode;
import javax.jms.QueueSession;
import javax.jms.QueueReceiver;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;

import java.util.Hashtable;

public class SenderListener
{
    public static void main(String[] args) throws Exception
    {
	// get the initial context
	InitialContext ctx = new InitialContext();

	// lookup the queue object
	Queue queue = (Queue) ctx.lookup("queue/queue0");

	// lookup the queue connection factory
	QueueConnectionFactory connFactory = (QueueConnectionFactory) ctx.
	    lookup("queue/connectionFactory");

	// create a queue connection
	QueueConnection queueConn = connFactory.createQueueConnection();

	// create a queue session
	QueueSession queueSession = queueConn.createQueueSession(false,
	    Session.DUPS_OK_ACKNOWLEDGE);

	// create a queue sender
	QueueSender queueSender = queueSession.createSender(queue);
	queueSender.setDeliveryMode(DeliveryMode.PERSISTENT);

	// create an Object message
     	ObjectMessage objectmsg = queueSession.createObjectMessage();
     	Hashtable hTable = new Hashtable();
     	hTable.put("color","red");
     	hTable.put("item","sauce");	        		     
     	objectmsg.setObject(hTable);
	        	
      System.out.println("Message sent. "+objectmsg.getObject());
     	queueSender.send(objectmsg);

	// create a Text message
     	TextMessage textmsg= queueSession.createTextMessage();
     	textmsg.setText("hello world");
	        	
      System.out.println("Message sent. "+textmsg.getText());
      queueSender.send(textmsg);

	// create a finish Text message
     	textmsg.setText("finish");
	        	
      System.out.println("Message sent. "+textmsg.getText());
      queueSender.send(textmsg);

	// close the queue connection
	queueConn.close();
    }
}
