package ptp;

import javax.jms.Queue;

import javax.naming.Context;
import javax.naming.InitialContext;

import javax.jms.Queue;
import javax.jms.Session;
import javax.jms.Message;
import javax.jms.QueueSender;
import javax.jms.QueueSession;
import javax.jms.QueueReceiver;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;

public class SimpleReceiver
{
    public static void main(String[] args) throws Exception
    {
	// get the initial context
	InitialContext ctx = new InitialContext();

	// lookup the queue object
	Queue queue = (Queue) ctx.lookup("queue/queue0");

	// lookup the queue connection factory
	QueueConnectionFactory connFactory = (QueueConnectionFactory) ctx.
	    lookup("queue/connectionFactory");

	// create a queue connection
	QueueConnection queueConn = connFactory.createQueueConnection();

	// create a queue session
	QueueSession queueSession = queueConn.createQueueSession(false,
	    Session.DUPS_OK_ACKNOWLEDGE);

	// create a queue receiver
	QueueReceiver queueReceiver = queueSession.createReceiver(queue);

	// start the connection
	queueConn.start();

	// get the number of messages to receive
	int numMsgs = (args.length > 0) ? new Integer(args[0]).intValue() : 500;

	// receive the messages
	for (int i=0; i < numMsgs; i++) {
	    Message message = queueReceiver.receive();
	    System.out.println("Received msg#"+(i+1));
	}

	// close the queue connection
	queueConn.close();
    }
}
