package pubsub;

import javax.jms.Topic;

import javax.naming.Context;
import javax.naming.InitialContext;

import javax.jms.Topic;
import javax.jms.Session;
import javax.jms.Message;
import javax.jms.TopicPublisher;
import javax.jms.DeliveryMode;
import javax.jms.TopicSession;
import javax.jms.TopicConnection;
import javax.jms.TopicConnectionFactory;

public class SimplePublisher
{
    public static void main(String[] args) throws Exception
    {
	// get the initial context
	InitialContext ctx = new InitialContext();

	// lookup the topic object
	Topic topic = (Topic) ctx.lookup("topic/topic0");

	// lookup the topic connection factory
	TopicConnectionFactory connFactory = (TopicConnectionFactory) ctx.
	    lookup("topic/connectionFactory");

	// create a topic connection
	TopicConnection topicConn = connFactory.createTopicConnection();

	// create a topic session
	TopicSession topicSession = topicConn.createTopicSession(false, 
	    Session.AUTO_ACKNOWLEDGE);

	// create a topic publisher
	TopicPublisher topicPublisher = topicSession.createPublisher(topic);
	topicPublisher.setDeliveryMode(DeliveryMode.NON_PERSISTENT);

	// create a simple message
	Message message = topicSession.createMessage();

	// get the number of messages to publish
	int numMsgs = (args.length > 0) ? new Integer(args[0]).intValue() : 500;

	// publish the messages
	for (int i=0; i < numMsgs; i++) { 
	    topicPublisher.publish(message);
	    System.out.println("Published msg#"+(i+1));
	}

	// close the topic connection
	topicConn.close();
    }
}
